<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>requester</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css"
          integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
    <link rel="stylesheet" href="/assets/style.css">
    <script src="/assets/main.js"></script>
</head>
<body>
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <h2>Evaluator</h2>
</nav>
<ul class="nav nav-tabs" id="myTab" role="tablist">
    <li class="nav-item" role="presentation">
        <a id="tab-home" href="#home" aria-controls="home" class="nav-link active" data-toggle="tab" role="tab"
           aria-selected="true">Home</a>
    </li>
    <li class="nav-item" role="presentation">
        <a id="tab-storm-config-content" href="#storm-config-content" aria-controls="storm-config-content"
           class="nav-link" data-toggle="tab" role="tab">
            Storm Config
        </a>
    </li>
    <li class="nav-item" role="presentation">
        <a id="tab-logs" href="#logs" aria-controls="logs" class="nav-link" data-toggle="tab" role="tab">
            StormDeployLogs
        </a>
    </li>
    <li class="nav-item" role="presentation">
        <a id="tab-metrics" href="#metrics" aria-controls="metrics" class="nav-link" data-toggle="tab" role="tab">
            TopoMetrics
        </a>
    </li>
    <li class="nav-item" role="presentation">
        <a id="tab-meta" href="#meta" aria-controls="meta" class="nav-link" data-toggle="tab" role="tab">
            Metadata
        </a>
    </li>
</ul>
<main class="container">
    <div class="tab-content" id="tabsContent">
        <div class="tab-pane fade show active" id="home" role="tabpanel" aria-labelledby="tab-home">
            <div class="row">
                <div class="col-6">
                    <h3>Topology Config JSON</h3>
                    <div class="form-group mb-2">
                        <textarea name="storm-config" id="topo-config" class="form-control"
                                  rows="10">{{topoConfig}}</textarea>
                    </div>
                    <div class="form-group row">
                        <div class="col">
                            <button class="btn btn-secondary" id="addRun">+ Add Run</button>
                        </div>
                        <div class="col">
                            <div class="form-check form-check-inline">
                                <input class="form-check-input" type="radio" name="topologyRadio" id="topoSeal"
                                       value="WordCountSeal" checked>
                                <label class="form-check-label" for="topoSeal">
                                    WordCountSeal
                                </label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input class="form-check-input" type="radio" name="topologyRadio" id="topoTrident"
                                       value="WordCountTrident">
                                <label class="form-check-label" for="topoTrident">
                                    WordCountTrident
                                </label>
                            </div>
                        </div>

                    </div>
                    <div class="mt-4">
                        <button class="btn btn-primary mr-4" id="setTopoConfig">Set JSON</button>
                        <button class="btn btn-danger mr-4" id="deployJar">Deploy</button>
                    </div>
                </div>
                <div class="col-6">
                    <h3>Infos</h3>
                    <div class="col">
                        <label>Gitlab Package</label>
                        <div id="package-info">
                            &nbsp;
                        </div>
                    </div>
                    <div class="col">
                        <label>Supervisors</label>
                        <div id="supervisors"></div>
                    </div>
                </div>
            </div>
            <hr>
            <div class="row">
                <div class="col-12">
                    <h3>Test Runs
                        <sup><small>
                            <a class="btn btn-outline-secondary btn-sm" onclick="toStorage('#allTestRuns')">save</a>
                            /
                            <a class="btn btn-outline-secondary btn-sm" onclick="fromStorage()">load</a>
                        </small></sup>
                    </h3>
                    <div>
                        <strong class="d-block">
                            <input type="checkbox" id="nextOnUptime" disabled>
                            <label for="nextOnUptime">
                                Do Next, every:
                            </label>
                        </strong>
                        <strong class="d-block">
                            <input type="checkbox" id="nextOnUptime8" class="uptimeInterval" value="8">
                            <label for="nextOnUptime8">
                                8 Minutes
                            </label>
                        </strong>
                        <strong class="d-block">
                            <input type="checkbox" id="nextOnUptime10" class="uptimeInterval" value="10">
                            <label for="nextOnUptime10">
                                10 Minutes
                            </label>
                        </strong>
                        <strong class="d-block">
                            <input type="checkbox" id="nextOnUptime15" class="uptimeInterval" value="15">
                            <label for="nextOnUptime15">
                                15 Minutes
                            </label>
                        </strong>
                        <strong class="d-block">
                            <input type="checkbox" id="nextOnUptime20" class="uptimeInterval" value="20">
                            <label for="nextOnUptime20">
                                20 Minutes
                            </label>
                        </strong>
                        <strong class="d-block">
                            <input type="checkbox" id="filterDone" checked>
                            <label for="filterDone">
                                Filter DONE
                            </label>
                        </strong>
                    </div>
                    <div id="allTestRuns"></div>
                    <table class="col-12">
                        <thead>
                        <tr>
                            <th>#</th>
                            <th>Type</th>
                            <th>Deploy</th>
                            <th>Workload</th>
                            <th>Fail Rate</th>
                            <th>Scaling</th>
                            <th></th>
                        </tr>
                        </thead>
                        <tbody id="runs">

                        </tbody>
                    </table>
                </div>
            </div>
            <hr>
            <div class="row">
                <div class="col-12">
                    <h3>Topologies</h3>
                    <div class="row container" id="topologies"></div>
                </div>
            </div>
        </div>
        <div class="tab-pane fade" id="storm-config-content" role="tabpanel" aria-labelledby="tab-storm-config-content">
            <div class="row">
                <div class="col-12">
                    <h3>Storm Config YAML</h3>
                    <div class="form-group">
                <textarea name="storm-config" id="storm-config" class="form-control"
                          rows="15">{{stormConfig}}</textarea>
                    </div>
                    <button class="btn btn-primary" id="setStormConfig">Set YAML</button>
                </div>
            </div>
        </div>
        <div class="tab-pane fade" id="logs" role="tabpanel" aria-labelledby="tab-logs">
            <div>
                <button class="btn btn-primary" onclick="getLogsStormDeploy()">refresh</button>
                <hr>
            </div>
            <div id="logLines"></div>
        </div>
        <div class="tab-pane fade" id="metrics" role="tabpanel" aria-labelledby="tab-metrics">
            <div>
                <button class="btn btn-primary" onclick="getLogsMetrics()">refresh</button>
                <hr>
            </div>
            <div id="metricLines"></div>
        </div>
        <div class="tab-pane fade" id="meta" role="tabpanel" aria-labelledby="tab-meta">
            <div>
                <button class="btn btn-primary" onclick="copyMetadata()">copy</button>
                <hr>
            </div>
            <table>
                <thead>
                    <tr>
                        <th>id</th>
                        <th>workload</th>
                        <th>failEveryNth</th>
                        <th>replicaTextSpout</th>
                        <th>replicaSplitBolt</th>
                        <th>replicaCountBolt</th>
                        <th>replicaCommitBolt</th>
                    </tr>
                </thead>
                <tbody id="metaLines"></tbody>
            </table>
        </div>
    </div>
    <hr>
    <div class="row">
        <div class="col-12">
            <h3>Message Log</h3>
            <div id="deployMessage">
                <div class="card">
                    <div class="card-header" id="heading[[id]]">
                        <h5 class="mb-0">
                            <button class="btn btn-link" data-toggle="collapse" data-target="#collapse[[id]]"
                                    aria-expanded="true" aria-controls="collapse[[id]]">
                                [[title]]
                            </button>
                        </h5>
                    </div>

                    <div id="collapse[[id]]" class="collapse show" aria-labelledby="heading[[id]]"
                         data-parent="#deployMessage">
                        <div class="card-body">
                            [[text]]
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</main>

<template id="templateLogLine">
    <div class="card">
        <div class="card-header" id="heading-log-[[id]]">
            <h5 class="mb-0">
                <button class="btn btn-link" data-toggle="collapse" data-target="#collapse-log-[[id]]"
                        aria-expanded="true" aria-controls="collapse-log-[[id]]">
                    [[title]]
                </button>
            </h5>
        </div>

        <div id="collapse-log-[[id]]" class="collapse show" aria-labelledby="heading-log-[[id]]"
             data-parent="#deployMessage">
            <div class="card-body">
                [[text]]
            </div>
        </div>
    </div>
</template>
<template id="templateMetadataRow">
    <tr>
        <td>[[id]]</td>
        <td>[[workload]]</td>
        <td>[[failEveryNth]]</td>
        <td>[[replicaTextSpout]]</td>
        <td>[[replicaSplitBolt]]</td>
        <td>[[replicaCountBolt]]</td>
        <td>[[replicaCommitBolt]]</td>
    </tr>
</template>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js"></script>
</body>
</html>
